; Source created with Parsic Version 3.x

; at              : 14/08/02 19.09.51


; Project File    : c:\PROGRA~1\PARSIC\PWM\A1PILOT.PIC

; Project Version : 1.0.8

; Created         : 22/01/02 21.08.00

; Last change     : 14/08/02 19.09.44

	PROCESSOR 16F628

	INCLUDE P16F628.INC

	RADIX DEC


	__IDLOCS H'0100'

	__CONFIG _CP_OFF & _PWRTE_ON & _WDT_ON & _BODEN_ON & _XT_OSC & _LVP_OFF & _MCLRE_ON

; Diverses

ZERO	EQU Z	; ZERO-Flag
CARRY	 EQU C	; CARRY-Flag


; Variable

TMR0H	= 32	; located in Bank 0
RBSTATUS	= 33	; located in Bank 0
RBCHANGED	= 34	; located in Bank 0
RBTMP	= 35	; located in Bank 0
RB4STARTTIME	= 36	; located in Bank 0
RB4STARTTIME_HI	= 37	; located in Bank 0
RB4TIME	= 38	; located in Bank 0
RB4TIME_HI	= 39	; located in Bank 0
S0	= 40	; located in Bank 0
S0_HI	= 41	; located in Bank 0
MF1	= 42	; located in Bank 0
MF1_HI	= 43	; located in Bank 0
MF1_FD	= 44	; located in Bank 0
S3	= 45	; located in Bank 0
S1	= 46	; located in Bank 0
S1_HI	= 47	; located in Bank 0
TR1	= 48	; located in Bank 0
TR1_HI	= 49	; located in Bank 0
S2	= 50	; located in Bank 0
OS1_FD	= 51	; located in Bank 0
RAM	= 52	; located in Bank 0
SYS_WSAV	= 112	; located in Bank 0, 1, 2, 3
SYS_SSAV	= 113	; located in Bank 0, 1, 2, 3
SYS_TMP1	= 114	; located in Bank 0, 1, 2, 3

	ERRORLEVEL -302	; disable warning (Bankswitching)
	ERRORLEVEL -306	; disable warning (Pageswitching)

;****************************************
;Programmanfang
;****************************************

	ORG 0

	CLRF STATUS	; switch to RAM-Bank 0
	GOTO SYS_INIT
	NOP
	NOP

	MOVWF SYS_WSAV	; save register
	SWAPF STATUS,W
	CLRF STATUS	; Bank 0
	MOVWF SYS_SSAV

	BTFSC INTCON,RBIF	; RBIF ?
	GOTO RBIF_INTERRUPT2

	INCF TMR0H,F	; High-Byte von TMR0

	BCF INTCON,T0IF	; Interrupt quitieren

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	INCFSZ MF1,F
	GOTO SYS_INT_LABEL_0
	INCF MF1_HI,F

SYS_INT_LABEL_0
	INCFSZ TR1,F
	GOTO SYS_INT_LABEL_1
	INCF TR1_HI,F

SYS_INT_LABEL_1
	BTFSS INTCON,RBIF	; RBIF ?
	GOTO EXITINT2

RBIF_INTERRUPT2
	BCF INTCON,RBIF	; clear Interrupt-Flag

; Stop Timer0
	BSF STATUS,RP0	; Bank 1
	BSF OPTION_REG,T0CS	; external source

	BCF STATUS,RP0	; Bank 0
	MOVFW PORTB	; which changed ?
	MOVWF RBTMP
	XORWF RBSTATUS,W
	MOVWF RBCHANGED
	MOVFW RBTMP
	MOVWF RBSTATUS

	BTFSC INTCON,T0IF	; TMR0 Interrupt ?
	INCF TMR0H,F	; High-Byte from TMR0
	BCF INTCON,T0IF	; clear Interrupt-Flag

TESTRB4
	BTFSC RBCHANGED,4	; RB4
	GOTO CHECKRB4
	GOTO EXITINT	 ; Oh

CHECKRB4	BTFSC RBSTATUS,4
	GOTO CHECKRB4START

	MOVFW RB4STARTTIME_HI
	SUBWF TMR0H,W
	MOVWF RB4TIME_HI
	MOVFW RB4STARTTIME
	SUBWF TMR0,W
	MOVWF RB4TIME
	BTFSS STATUS,CARRY
	DECF RB4TIME_HI,F

	GOTO EXITINT

CHECKRB4START
	MOVFW TMR0H
	MOVWF RB4STARTTIME_HI
	MOVFW TMR0
	ADDLW D'225'
	MOVWF RB4STARTTIME
	BTFSS STATUS,CARRY
	DECF RB4STARTTIME_HI,F

	GOTO EXITINT

EXITINT
	BSF STATUS,RP0	; Bank 1
	BCF STATUS,RP1	; Bank 1
	BCF OPTION_REG,T0CS	; internal source

EXITINT2
	CLRF STATUS
	SWAPF SYS_SSAV,W	; restore register
	MOVWF STATUS
	SWAPF SYS_WSAV,F
	SWAPF SYS_WSAV,W

	RETFIE	; RETurn From Interrupt and Enable GIE

;****************************************
; Subroutines
;****************************************


;****************************************
;Initialisierung
;****************************************


SYS_INIT

	MOVLW B'00101000'
	MOVWF INTCON

; Ausgangs-Pegel setzen, bevor die Richtung gesetzt wird

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVLW B'00000000'
	MOVWF PORTA

	MOVLW B'00000000'
	MOVWF PORTB

	MOVLW 143
	BSF STATUS,RP0	; Bank 1
	MOVWF OPTION_REG


; Richtung setzen

	MOVLW B'11111110'
	MOVWF TRISA

	MOVLW B'11111111'
	MOVWF TRISB

	BCF STATUS,RP0	; Bank 0
	MOVLW 7	; Comparators off
	MOVWF CMCON
; init vars


; Clear RAM

	BCF STATUS,IRP
	MOVLW 32
	MOVWF FSR
CR1
	CLRF INDF
	INCF FSR,F
	BTFSS FSR,7
	GOTO CR1
	BSF FSR,5
CR2
	CLRF INDF
	INCF FSR,F
	MOVLW H'F0'
	SUBWF FSR,W
	BTFSS STATUS,ZERO
	GOTO CR2
	BSF STATUS,IRP
	MOVLW 32
	MOVWF FSR
CR3
	CLRF INDF
	INCF FSR,F
	MOVLW H'50'
	SUBWF FSR,W
	BTFSS STATUS,ZERO
	GOTO CR3


	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	CLRF TMR0
	BCF INTCON,T0IF
	BSF INTCON,GIE	; Interrupt freigeben

;**********************************
;******* Haupt-Programm ***********
;**********************************

MAIN

	CLRWDT

;***************************************************
; Limiter -> LM1
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVFW RB4TIME
	MOVWF S0
	MOVFW RB4TIME_HI
	MOVWF S0_HI

	MOVLW HIGH 2000
	SUBWF S0_HI,W
	BTFSS STATUS,ZERO
	GOTO LABEL_LM1_CHECK1
	MOVLW LOW 2000
	SUBWF S0,W
LABEL_LM1_CHECK1
	BTFSS STATUS,CARRY
	GOTO LABEL_LM1_BOTTOM
	BTFSC STATUS,ZERO
	GOTO LABEL_LM1_BOTTOM
	MOVLW LOW 2000
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVWF S0
	MOVLW HIGH 2000
	MOVWF S0_HI
	GOTO LABEL_LM1_EXIT
LABEL_LM1_BOTTOM
	MOVLW HIGH 1000
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	SUBWF S0_HI,W
	BTFSS STATUS,ZERO
	GOTO LABEL_LM1_CHECK2
	MOVLW LOW 1000
	SUBWF S0,W
LABEL_LM1_CHECK2
	BTFSC STATUS,CARRY
	GOTO LABEL_LM1_EXIT
	MOVLW LOW 1000
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVWF S0
	MOVLW HIGH 1000
	MOVWF S0_HI
LABEL_LM1_EXIT

;***************************************************
; Mono-Flop -> MF1
;***************************************************

; Test auf positive Flanke

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC MF1_FD,0
	GOTO LABEL_MF1_CHKTIME
	BTFSS RBTMP,4
	GOTO LABEL_MF1_CHKTIME


LABEL_MF1_RESET

	CLRF MF1
	CLRF MF1_HI
	BSF MF1_FD,1
	BSF S3,0

LABEL_MF1_CHKTIME

; Luft der Impuls ?

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS MF1_FD,1
	GOTO LABEL_MF1_SETFD

	MOVLW 15
	SUBWF MF1_HI,W
	BTFSS STATUS,ZERO
	GOTO LABEL_MF1_CHECK
	MOVLW 66
	SUBWF MF1,W
LABEL_MF1_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_MF1_SETFD
LABEL_MF1_TO

	BCF MF1_FD,1
	BCF S3,0

LABEL_MF1_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS RBTMP,4
	GOTO LABEL_MF1_CLR
	BSF MF1_FD,0
	GOTO LABEL_MF1_ENDE
LABEL_MF1_CLR
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF MF1_FD,0

LABEL_MF1_ENDE

;***************************************************
; Multiplexer -> MX1
;***************************************************

	CLRF SYS_TMP1
	MOVFW S2
	BTFSS STATUS,ZERO
	GOTO LABEL_MX1_CHECKCONTROL1

	MOVLW LOW 1000
	MOVWF S1
	MOVLW HIGH 1000
	MOVWF S1_HI
	GOTO LABEL_MX1_END

LABEL_MX1_CHECKCONTROL1
	INCF SYS_TMP1,F
	MOVFW S2
	SUBWF SYS_TMP1,W
	BTFSS STATUS,ZERO
	GOTO LABEL_MX1_CHECKCONTROL2

	MOVFW S0
	MOVWF S1
	MOVFW S0_HI
	MOVWF S1_HI
	GOTO LABEL_MX1_END

LABEL_MX1_CHECKCONTROL2

LABEL_MX1_END

;***************************************************
; Impuls -> PO1
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S3,1
	GOTO LABEL_PO1_EXIT

	MOVLW 250
	SUBWF S1,W
	BTFSC STATUS,ZERO
	GOTO LABEL_PO1_0
	BTFSS STATUS,CARRY
	GOTO LABEL_PO1_0

	MOVLW 250
	MOVWF S1

LABEL_PO1_0
	MOVFW S1
	IORWF S1_HI,W
	BTFSC STATUS,ZERO
	GOTO LABEL_PO1_EXIT
	CLRF TMR0
	CLRF TMR0H

	BSF PORTA,0

LABEL_PO1_1
	CLRWDT
	MOVFW S1_HI
	SUBWF TMR0H,W
	BTFSS STATUS,ZERO
	GOTO LABEL_PO1_1

LABEL_PO1_2
	BCF INTCON,GIE
	BTFSC INTCON,GIE
	GOTO LABEL_PO1_2

LABEL_PO1_3
	MOVFW S1
	SUBWF TMR0,W
	BTFSS STATUS,CARRY
	GOTO LABEL_PO1_3

	BCF PORTA,0

	CLRF S1
	CLRF S1_HI
	BSF INTCON,GIE

LABEL_PO1_EXIT

;***************************************************
; Timer -> TR1
;***************************************************

	MOVLW 0	; Test auf >=
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	SUBWF TR1_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR1_CHECK
	MOVLW 39
	SUBWF TR1,W	;F-W -> W
LABEL_TR1_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR1_ENDE

LABEL_TR1_RESET
	MOVLW 0	; Test auf >=
	SUBWF TR1_HI,F	;F-W -> F
	MOVLW 39
	SUBWF TR1,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR1_HI,F

LABEL_TR1_SET	; toggel output
	BTFSC S3,2
	GOTO LABEL_TR1_CLR
	BSF S3,2
	GOTO LABEL_TR1_ENDE
LABEL_TR1_CLR
	BCF S3,2
LABEL_TR1_ENDE

;***************************************************
; Verteiler -> BV1
;***************************************************

	MOVLW 0 
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S3,0	; IN0
	IORLW 1
	MOVWF S2	; OUT

;***************************************************
; One Shot -> OS1
;***************************************************


	BTFSS S3,2
	GOTO LABEL_OS1_1
	BTFSC OS1_FD,0
	GOTO LABEL_OS1_1
	BSF OS1_FD,0
	BSF S3,1
	GOTO LABEL_OS1_2
LABEL_OS1_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S3,1
	BTFSC S3,2
	GOTO LABEL_OS1_2
	BCF OS1_FD,0
LABEL_OS1_2
;****************************************

	GOTO MAIN


	END

